package Spec;

import br.ufpe.abaco.gui.*;
import br.ufpe.abaco.compiler.*;
import br.ufpe.abaco.ActionInterpreter.*;
import java.util.*;

import javax.swing.*;

public class ActionStackImplementation {


    public static void register(CompiledSpecification spec) {

	final Interpreter interp = (Interpreter)spec.getKey("ActionInterpreter");
	final HashMap stackList = new HashMap();
	interp.insertEvaluator("push _ _", new br.ufpe.abaco.ActionInterpreter.ActionEvaluator() {
		public RuntimeAction evaluateAction(Term action, RuntimeAction income) throws PerformanceException  {
		    Term t = evaluateYielder(action.getLeaf(0),income);
		    Object obj = stackList.get(action.getLeaf(1));
		    if (obj==null) {
			obj = new Stack();
			stackList.put(action.getLeaf(1),obj);
		    }
		    Stack st = (Stack)obj;
		    st.push(t);
		    return new RuntimeAction(null,null);
		}
	    });
	interp.insertEvaluator("pop _", new br.ufpe.abaco.ActionInterpreter.ActionEvaluator() {
		public RuntimeAction evaluateAction(Term action, RuntimeAction income) throws PerformanceException  {
		    Object obj = stackList.get(action.getLeaf(0));
		    if (obj==null) {
			parent.fail(action,income);
		    }
		    Stack st = (Stack)obj;
		    return new RuntimeAction((Term)st.pop(),null);
		}
	    });
	interp.insertEvaluator("top _", new br.ufpe.abaco.ActionInterpreter.ActionEvaluator() {
		public RuntimeAction evaluateAction(Term action, RuntimeAction income) throws PerformanceException  {
		    Object obj = stackList.get(action.getLeaf(0));
		    if (obj==null) {
			parent.fail(action,income);
		    }
		    Stack st = (Stack)obj;
		    return new RuntimeAction((Term)st.peek(),null);
		}
	    });


    }

    public static String[] dependencies() {
	return new String[] { "br.ufpe.abaco.ActionInterpreter.Interpreter" };
    }

}
