package Spec;

import java.util.*;
import br.ufpe.abaco.compiler.*;


public class SetTerm extends AtomicTerm {
    Set set;
    StandardOperators stan;

    public SetTerm(Set s,StandardOperators st) {
	set = s;
	stan = st;;
    }
    
    public String toString() {
	StringBuffer b = new StringBuffer();
	b.append("set of ( ");
	Iterator i = set.iterator();
	while (i.hasNext()) {
	    b.append(i.next());
	    if (i.hasNext())
		b.append(" , ");
	}
	b.append(" )");
	return b.toString();
    }
        
    public boolean equals(Object o) {
	if (o instanceof SetTerm)
	    return ((SetTerm)o).set.equals(set);
	return false;
    }
    
    public int hashCode() {
	return set.hashCode();
    }

    public SetTerm union(SetTerm s) {
	HashSet nSet = new HashSet();
	nSet.addAll(set);
	nSet.addAll(s.set);
	return new SetTerm(nSet,stan);
    }
    
    public SetTerm difference(SetTerm s) {
	HashSet nSet = new HashSet();
	nSet.addAll(set);
	nSet.removeAll(s.set);
	return new SetTerm(nSet,stan);
	
    }
    public SetTerm intersection(SetTerm s) {
	HashSet nSet = new HashSet();
	nSet.addAll(set);
	nSet.retainAll(s.set);
	return new SetTerm(nSet,stan);
	
    }

    public boolean isIn(Term t) {
	return set.contains(t);
    }

    public boolean isIncluded(SetTerm s) {
	return set.containsAll(s.set);
    }

    public Term elements() {


	int size = set.size();
	if (size==0) {
	    return new SimpleTerm(stan.emptyTupleOp,0);
	} else if (size==1) {
	    return (Term)set.iterator().next();
	} else {
	    Term elems[] = new Term[size];
	    Iterator i = set.iterator();
	    int c = 0;
	    while(i.hasNext()) 
		elems[c++] = (Term)i.next();
	    return new TupleTerm(elems,0,stan);
	}
    }

    
    
}
